EDIT - bug #6730

Deleting media leads to inconsistent data
06/15/2017 01:27 PM - Andreas Mller

Status: Resolved Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 90%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 4.10

Severity: critical Found in Version:

Description

The same problem as described in #6527#note-6 also appears in media bulk editor if you try to delete a media that is used for a
protolog (TaxonNameDescription). The check only seems to check for TaxonDescription and SpecimenDescription. But there are
multiple places where media can be added and reference. We ALWAYS need a general getReferencingObjects check in case any
unexpected reference still exists. This is also important for model changes.

Currently if you delete the image and afterwards you open the name the protolog was attached to you get an
ObjectNotFoundException exception which pops up in loop (this should also never happen, for NO exception, please feel free to
open a new ticket for this).

login : admin
editor version : 4.8.0.201706150749
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 4.7.0.0.201710040000
os : Windows Server 2012 R2 6.3 amdo64
java : 1.8.0_121
org.eclipse.swt.SWTException: Failed to execute runnable (eu.etaxonomy.taxeditor.remoting.CdmEager
LoadingException: org.hibernate.ObjectNotFoundException: No row with the given identifier exists:
[eu.etaxonomy.cdm.model . .media.Media#221])

at org.eclipse.swt.SWT.error (SWT. java:4533)

at org.eclipse.swt.SWT.error (SWT. java:4448)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer.java:185)

at org.eclipse.swt.widgets.Display.runAsyncMessages (Display.java:4211)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3827)

at org.eclipse.jface.window.Window.runEventLoop (Window.java:818)

at org.eclipse.jface.window.Window.open (Window. java:794)

at org.eclipse.jface.dialogs.ErrorDialog.open (ErrorDialog. java:346)

at eu.etaxonomy.taxeditor.model.MessagingUtils$l.run (MessagingUtils.java:279)

at org.eclipse.swt.widgets.RunnableLock.run (RunnableLock. java:35)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer.java:182)

at org.eclipse.swt.widgets.Display.runAsyncMessages (Display.java:4211)

at org.eclipse.swt.widgets.Display.readAndDispatch(Display.java:3827)

at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java
:1121)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1l
022)

at org.eclipse.ed.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application.java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle.java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLaunc
her.java:134)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLlLauncher.start (EclipseAppLauncher. java:
104)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter.java:243)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
at org.hibernate.persister.collection.AbstractCollectionPersister.readElement (AbstractCollecti
onPersister.java:833)

at org.hibernate.collection.internal.PersistentlList.readFrom(PersistentList.java:382)

at org.hibernate.loader.Loader.readCollectionElement (Loader. java:1353)

at org.hibernate.loader.Loader.readCollectionElements (Loader. java:892)

at org.hibernate.loader.Loader.getRowFromResultSet (Loader. java:738)

at org.hibernate.loader.Loader.processResultSet (Loader.java:972)

at org.hibernate.loader.Loader.doQuery (Loader. java:930)

at org.hibernate.loader.Loader.doQueryAndInitializeNonLazyCollections (Loader. java:336)

at org.hibernate.loader.Loader.dolList (Loader.java:2611)

at org.hibernate.loader.Loader.dolList (Loader.java:2594)

at org.hibernate.loader.Loader.listIgnoreQueryCache (Loader. java:2423)

at org.hibernate.loader.Loader.list (Loader.java:2418)

at org.hibernate.loader.hgl.QueryLoader.list (QueryLoader.java:501)

at org.hibernate.hgl.internal.ast.QueryTranslatorImpl.list (QueryTranslatorImpl. java:371)

at org.hibernate.engine.query.spi.HQLQueryPlan.performList (HQLQueryPlan. java:216)

at org.hibernate.internal.SessionImpl.list (SessionImpl.java:1326)

at org.hibernate.internal.QueryImpl.list (QueryImpl.java:87)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.bulkLoadLazyCollection
s (AdvancedBeanInitializer.java:526)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.bulkLoadLazies (Advance
dBeanInitializer.java:435)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeNodeNoWildca
rd (AdvancedBeanInitializer. java:244)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeNode (Advance
at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeNodeRecursiv
e (AdvancedBeanInitializer.java:105)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeNodeRecursiv
e (AdvancedBeanInitializer. java:107)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initializeAll (Advanced
BeanInitializer. java:85)

at eu.etaxonomy.cdm.persistence.dao.initializer.AdvancedBeanInitializer.initialize (AdvancedBea
nInitializer.java:57)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmEntityDaoBase.load (CdmEntityDaoBase. ja
va:665)

at eu.etaxonomy.cdm.persistence.dao.hibernate.common.CdmGenericDaoImpl.initializeCollection (Cd
mGenericDaoImpl. java:868)

at eu.etaxonomy.cdm.api.service.CommonServiceImpl.initializeCollection (CommonServiceImpl. java:
351)

at sun.reflect.GeneratedMethodAccessor2070.1invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:497)

at org.springframework.aop.support.RAopUtils.invokeJoinpointUsingReflection (AopUtils.java:302)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMeth
odInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:157)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (
TransactionInterceptor. java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransactio
n(TransactionAspectSupport. java:281)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterc
Related issues:
Related to EDIT - bug #6915: Delete does not work in media view for taxon Closed

Associated revisions

Revision 74eabaa7 - 06/19/2017 08:56 AM - Katja Luther

ref #6730: first quick fix, to avoid deleting media referenced somewhere else.

Revision 6bd4c0bd - 06/19/2017 08:56 AM - Katja Luther
ref #6730: minor
Revision 7620acb4 - 06/20/2017 02:02 PM - Katja Luther
ref #6730: fix delete of media

Revision 2b6e8d64 - 06/20/2017 02:10 PM - Katja Luther
ref #6730: fix delete of media

Revision f35bd02a - 06/20/2017 03:07 PM - Patrick Plitzner
ref #6730 Adapt to cdmlib changes

Revision 3544255d - 09/14/2017 04:09 PM - Katja Luther

ref #6730: minor changes in delete handler of bulk editor

Revision 8081ee07 - 09/14/2017 04:12 PM - Katja Luther

ref #6730: set result to Abort if media is used elsewhere

Revision 1e29f8¢7 - 09/15/2017 09:13 AM - Katja Luther

ref #6730: fix delete media if it is used in taxonnamedescription

Revision 51d2402d - 09/15/2017 09:15 AM - Katja Luther
ref #6730: minor

Revision 602c45a9 - 09/15/2017 09:18 AM - Katja Luther
ref #6730:adapt the messages

Revision 64e89f2c - 09/15/2017 09:38 AM - Katja Luther

ref #6730: updated objects need to be saved if media is deleted

Revision b8cf1412 - 09/21/2017 05:50 PM - Andreas Miiller
ref #6730 cleanup

Revision b8489aa9 - 09/21/2017 08:55 PM - Katja Luther

fix #6730: handle description elements of taxa, names and specimen all the same in media delete

Revision d8f50ab8 - 09/21/2017 10:06 PM - Andreas Miiller

ref #6730 remove some further redundant code in MediaServicelmpl.delete

Revision a509a0ab - 09/21/2017 10:51 PM - Andreas Miiller

ref #6730 try to remove compilation problem in MediaServicelmpl.delete

Revision 379f6670 - 09/22/2017 01:48 PM - Andreas Miiller

ref #6730 move updatedObject decleration into loop

Revision 2a44d1ef - 09/22/2017 02:40 PM - Andreas Miiller
ref #6730 further simplify/unify MediaServicelmpl.delete code

Revision 14e45274 - 09/22/2017 03:49 PM - Andreas Miiller

ref #6730 try to fix compilation error

Revision 223b2cd6 - 09/24/2017 09:11 PM - Katja Luther

approve media delete for multiple referenced media

Revision 36505ad4 - 09/24/2017 09:16 PM - Katja Luther

remove possibility of delete media of media specimen

Revision c40b1228 - 03/15/2022 09:36 AM - Katja Luther
ref #6730: only media of descriptions and protologues can be deleted if referenced

Revision f02cd83c - 03/15/2022 09:41 AM - Katja Luther

ref #6730: change message text for media deletion

History

#1 - 06/15/2017 01:27 PM - Andreas Miiller

- Description updated

#2 - 06/15/2017 01:29 PM - Andreas Miiller

- Description updated

#3 - 06/15/2017 01:33 PM - Andreas Miiller

| also do not fully understand why only the 2 explicit usecases "TaxonDescription" and "SpecimenDescription" are handled in the configurator. We
either need to have only one general option "if not used elsewhere" or we have to add a 3rd option "if not used at any other place" if we for some
reason want to keep these 2 explicit options.

See #6527 for other solutions (general we should try to use the same options throughout the application if somehow possible)

#4 - 07/21/2017 12:34 PM - Katja Luther

- Target version changed from Release 4.8 to Release 4.10

#5 - 08/15/2017 12:29 PM - Patrick Plitzner

- Related to bug #6915: Delete does not work in media view for taxon added

#6 - 09/01/2017 11:11 AM - Katja Luther

- Status changed from New to Resolved

now there are three options for deletion:

® only remove from gallery
e delete if not used somewhere else
¢ delete from everywhere

and if it is used anywhere else and should only if it not used somewhere else it is only removed from the image gallery.

please review

#7 - 09/01/2017 11:12 AM - Katja Luther
- Assignee changed from Katja Luther to Andreas Mdiller

- % Done changed from 0 to 80

#8 - 09/14/2017 03:35 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Katja Luther

- % Done changed from 80 to 40

The original problem (deleting a media from BULK editor which is e.g. referenced by a TaxonNameDescription via protologue) is not yet solved. It is
still possible to delete a media that is referenced.

In the configurator only 1 option was shown ("if not used elsewhere"). | did not check this checkbox. The delete was successful anyway and showed
the description (recursive) error message.

#9 - 09/14/2017 04:13 PM - Katja Luther

Andreas Milller wrote:
The original problem (deleting a media from BULK editor which is e.g. referenced by a TaxonNameDescription via protologue) is not yet solved.
It is still possible to delete a media that is referenced.

In the configurator only 1 option was shown ("if not used elsewhere"). | did not check this checkbox. The delete was successful anyway and
showed the description (recursive) error message.

The message was wrong because the isDeletable method returned ok, now it returns Abort and the message is correct and the line is not deleted.
#10 - 09/15/2017 09:39 AM - Katja Luther

- Status changed from Feedback to Resolved
now it should work as aspected.

#11 - 09/15/2017 11:15 AM - Andreas Miuiller

- Assignee changed from Katja Luther to Andreas Miiller

#12 - 09/21/2017 05:53 PM - Andreas Miiller

The "Delete" dialog now offers "Delete" or "Uberspringen" (sorry don't know what is shown in English version). Why not "Cancel"?

#13 - 09/21/2017 06:16 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

The general issue that inconsistent data is created and media are deleted if they shouldn't is fixed now.

However, the code to delete not only the media but also attached TextData and Descriptions is critical. E.g. when the media is attached to a normal
text data which contains text AND media the text data will be deleted together with the text. This is probably not wanted behavior.

the full deletion might be a good idea for image galleries, but not for normal text data. Probably we always need to check this.

Also | do not understand why the delete routine for TaxonDescription is different to the one for SpecimenDescription and NameDescription. Is this
only by mistake or is there a reason? If by mistake we should better extract the code into an own method to avoid redundant and error prone code.

Also at the end of the routine only in case of TaxonBase the updatedObiject is added to the result. Is this on purpose?
(please pull before changing code as | did some minor cleanup on the code)

#14 - 09/21/2017 06:16 PM - Andreas Miiller
- % Done changed from 40 to 60

#15 - 09/21/2017 08:56 PM - Katja Luther
- Status changed from Feedback to Resolved
- % Done changed from 60 to 50

Applied in changeset cdmlib|b8489aa95407f47ce7d81c2a308fd357bc6032a6.

#16 - 09/21/2017 09:23 PM - Andreas Miiller

Is this for review for me? All issues fixed?

#17 - 09/21/2017 09:25 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

hopefully yes, | moved the handling of the textdata in a separate method, check for text in textdata and added all updated objects to the result.

#18 - 09/21/2017 10:12 PM - Andreas Miiller

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

| did some further code cleaning (d8f50ab8), please check if you think this is correct.
While doing so | realized that

result.addUpdatedObject (updatedObject) ;

and all the other "updatedObject" related code is handled after

for (CdmBase ref: references) {}

This to me looks strange, as only the final updatedObject will be added. Shouldn't this be done for each updatedObject. Could you check if this needs
to be changed?
#19 - 09/22/2017 10:07 AM - Katja Luther

Andreas Muller wrote:
| did some further code cleaning (d8f50ab8), please check if you think this is correct.
While doing so | realized that
result.addUpdatedObject (updatedObject) ;

and all the other "updatedObject" related code is handled after

yes you are right, | moved this part of code into the for loop
for (CdmBase ref: references) {}

This to me looks strange, as only the final updatedObject will be added. Shouldn't this be done for each updatedObject. Could you check if this
needs to be changed?

#20 - 09/22/2017 10:07 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

#21 - 09/22/2017 03:00 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

This looks good now.

However, | tried to further simplify/unify the code and to set updatedObject always to null for each loop. See 2 commits. Please review if you think this
is correct.

#22 - 09/22/2017 03:00 PM - Andreas Miiller

While doing the refactoring | realized that | don't think we should allow Media being removed from MediaSpecimen. A MediaSpecimen is defined by
it's media, therefore removing it should not be allowed. Or have we discussed this differently in the past?

#23 - 09/22/2017 03:13 PM - Katja Luther

the refactored code looks fine.

you are right a media specimen without media does not make sense. | don't know anymore what we decided in the past. | would add it to the
isDeletable and delete method

#24 - 09/22/2017 03:20 PM - Andreas Miiller
By the way there are a couple of other places where Media is used. E.g. DefinedTermBase.getMedia, AmplificationResult.getMedia,
Sequence.getContigFile + getPherograms, MediaKey (used whereever keys are usable) and maybe more.

What is the expected behavior (of current code and in general) for these Media. Are they also deleted or do we get a warning that the media can't be
deleted? If the later than we definitely should remove MediaSpecimen from the list of deletable media and maybe adapt the configuration text to
something like "Delete from taxon and specimen descriptions or if used as protologue for taxon names"

#25 - 09/22/2017 03:24 PM - Andreas Miiller

Sorry if | have even one more issue. Looking at the code | wonder if the service.update(updatedObject) command is really necessary. My
understanding of update() is that the object is added(reattached) to the current session. But here, the updated object seems to be always loaded
within the current session, so no update (with cascading etc.) is needed. The changes to the updatedObject will always be saved if the
session/transaction is committed.

Is there a certain reason why we use update here?
#26 - 09/24/2017 09:21 PM - Katja Luther
Andreas Muller wrote:

By the way there are a couple of other places where Media is used. E.g. DefinedTermBase.getMedia, AmplificationResult.getMedia,
Sequence.getContigFile + getPherograms, MediaKey (used whereever keys are usable) and maybe more.
What is the expected behavior (of current code and in general) for these Media. Are they also deleted or do we get a warning that the media
can't be deleted? If the later than we definitely should remove MediaSpecimen from the list of deletable media and maybe adapt the
configuration text to something like "Delete from taxon and specimen descriptions or if used as protologue for taxon names"

The code now blocks the deletion (isDeletable returns Abort), may be have to discuss this again.

#27 - 03/17/2022 11:09 AM - Katja Luther

- Status changed from Feedback to Closed

- % Done changed from 50 to 100

Now only media of descriptions and protogues can be deleted if they are used more then once. The messages are adapted.
So | think we can close this ticket.

#28 - 03/17/2022 01:46 PM - Andreas Miiller

- Status changed from Closed to Feedback
- % Done changed from 100 to 90

Andreas Miiller wrote in #note-25:
Sorry if | have even one more issue. Looking at the code | wonder if the service.update(updatedObject) command is really necessary. My
understanding of update() is that the object is added(reattached) to the current session. But here, the updated object seems to be always loaded
within the current session, so no update (with cascading etc.) is needed. The changes to the updatedObject will always be saved if the
session/transaction is committed.

Is there a certain reason why we use update here?

Did you have a look on this, too? The call still seems to exist in line 191
#29 - 04/29/2022 02:33 PM - Katja Luther
Andreas Miiller wrote in #note-28:
Andreas Miiller wrote in #note-25:
Sorry if | have even one more issue. Looking at the code | wonder if the service.update(updatedObject) command is really necessary. My
understanding of update() is that the object is added(reattached) to the current session. But here, the updated object seems to be always
loaded within the current session, so no update (with cascading etc.) is needed. The changes to the updatedObject will always be saved if

the session/transaction is committed.

Is there a certain reason why we use update here?

Did you have a look on this, too? The call still seems to exist in line 191

| removed it and everything still works.

#30 - 04/29/2022 02:35 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

| think we can close this ticket now?
